#include "sv_helper.hpp"
#include <string>
#include <array>
#include <vector>
#include <iostream>
// #include <deque>

int main()
{
  const std::array arr{ 'd', 'u', 'm', 'm', 'y' };
  const std::vector<char> vec{ arr.cbegin(), arr.cend() };
  const std::string str{ arr.data(), arr.size() };
  const std::string_view svw{ str };
  const char* const ptr{ arr.data() }; // ohne Nullterminierung
  const char* const ntstr{ str.c_str() }; // nullterminierter String

  // +++ Das soll nicht kompilieren, da ein std::deque keinen zusammenhngenden Puffer hat:
  // const std::deque<char> deq{ arr.cbegin(), arr.cend() };
  // const auto err{ sv::make(deq) }; // keine berladung gefunden, denn ein std::deque hat keine data() Methode

  std::cout <<
    sv::make(ptr, 2) << '\n' << // die ersten 2 Zeichen des Strings
    sv::make(1, ptr, 2) << '\n' << // 1 Zeichen bersprungen, folgende 2 Zeichen des Strings
    sv::make(2, ntstr) << '\n' << // 2 Zeichen bersprungen, Rest des Strings (ACHTUNG: Nullterminierung erforderlich)
    sv::make(ntstr, 2, sv::tail{}) << '\n' << // 2 Zeichen vom Ende des Strings (ACHTUNG: Nullterminierung erforderlich)
    sv::make(ntstr) << '\n' << // kompletter String (ACHTUNG: Nullterminierung erforderlich)
    sv::make<char>() << '\n' << // leer
    sv::make(svw, 2) << '\n' << // die ersten 2 Zeichen des Views
    sv::make(1, svw, 2) << '\n' << // 1 Zeichen bersprungen, folgende 2 Zeichen
    sv::make(2, svw) << '\n' << // 2 Zeichen bersprungen, Rest des Views
    sv::make(svw, 2, sv::tail{}) << '\n' << // 2 Zeichen vom Ende des Views
    sv::make(svw) << '\n' << // Kopie des Views
    sv::make(sv::make<char>()) << '\n' << // Kopie eines leeren Views
    sv::make(str, 2) << '\n' << // die ersten 2 Zeichen des genutzten Puffers
    sv::make(1, arr, 2) << '\n' << // 1 Zeichen bersprungen, folgende 2 Zeichen des genutzten Puffers
    sv::make(2, vec) << '\n' << // 2 Zeichen bersprungen, Rest des genutzten Puffers
    sv::make(vec, 2, sv::tail{}) << '\n' << // 2 Zeichen vom Ende des genutzten Puffers
    sv::make(vec) << std::endl; // kompletter genutzter Puffer
}
